Object name/fr: Difference between revisions

From FreeCAD Documentation
No edit summary
(Created page with "Il existe différentes propriétés pour les noms: * Le {{incode|Name}} ne peut contenir que des caractères alphanumériques simples et le trait de soulignement, {{incode|[_0...")
Line 9: Line 9:
== Les Names ==
== Les Names ==


Il existe différentes propriétés pour les noms:
There are various properties for Names:
* The {{incode|Name}} can only include simple alphanumeric characters, and the underscore, {{incode|[_0-9a-zA-Z]}}.
* Le {{incode|Name}} ne peut contenir que des caractères alphanumériques simples et le trait de soulignement, {{incode|[_0-9a-zA-Z]}}.
* The {{incode|Name}} cannot start with a number; it must start with a letter or the underscore, {{incode|[_a-zA-Z]}}.
* Le {{incode|Name}} ne peut pas commencer par un nombre. Il doit commencer par une lettre ou le trait de soulignement, {{incode|[_a-zA-Z]}}.
* The {{incode|Name}} is assigned at the creation time of the object; afterwards it is no longer editable. The object can never be renamed.
* Le {{incode|Name}} est attribué au moment de la création de l'objet ensuite, il n'est plus modifiable. L'objet ne peut jamais être renommé.
* The {{incode|Name}} must be unique in the entire document. It doesn't matter if two objects are of completely different types, for example, one is a [[PartDesign_Pocket|PartDesign Pocket]] and the other is an [[Arch_Wall|Arch Wall]]. They must have different names.
* Le {{incode|Name}} doit être unique dans tout le document. Peu importe si deux objets sont de types complètement différents, par exemple, l'un est un [[PartDesign_Pocket/fr|PartDesign Poche]] et l'autre est un [[Arch_Wall/fr|Arch Mur]]. Ils doivent avoir des noms différents.
* When creating an object of the same type, normally the name is increased with a sequential number, thus {{incode|Box}}, {{incode|Box001}}, {{incode|Box002}}, etc. This prevents naming collision.
* Lors de la création d'un objet du même type, normalement le nom est augmenté d'un numéro séquentiel par exemple {{incode|Box}}, {{incode|Box001}}, {{incode|Box002}} etc.... Cela permet d'éviter la collusion des noms..
* Once the object is deleted, its {{incode|Name}} becomes available to be used by a newly created object. This means that if {{incode|Box}}, {{incode|Box001}}, and {{incode|Box002}} exist, and we delete the first item, the next box created with [[Part_Box|Part Box]] will not be {{incode|Box003}}, it will be {{incode|Box}} again, because this string is available to be used once more. Notice that it is not possible to rename {{incode|Box001}} or {{incode|Box002}} to {{incode|Box}} since their names are fixed.
* Une fois l'objet supprimé, son {{incode|Name}} devient disponible pour être utilisé par un objet nouvellement créé. Cela signifie que si {{incode|Box}}, {{incode|Box001}} et {{incode|Box002}} existent et que nous supprimons le premier élément, la boîte suivante créée avec [[Part_Box/fr|Part Cube]] ne sera pas {{incode|Box003}}, ce sera à nouveau {{incode|Box}}, cette chaîne étant disponible pour être réutilisée. Notez qu'il n'est pas possible de renommer {{incode|Box001}} ou {{incode|Box002}} en {{incode|Box}} car leurs noms sont fixes.


In summary, the {{incode|Name}} essentially acts like a unique identifier (UID) for an object. Since a unique {{incode|Name}} is very restrictive, all objects also have a {{incode|Label}} property which allows "renaming" the object to something more descriptive. The internal {{incode|Name}} actually remains fixed, but the user editable {{incode|Label}} can be used in most situations where the {{incode|Name}} would be used. In common usage in the program and the documentation, "renaming" means changing the {{incode|Label}} and not the actual {{incode|Name}} of the object.
In summary, the {{incode|Name}} essentially acts like a unique identifier (UID) for an object. Since a unique {{incode|Name}} is very restrictive, all objects also have a {{incode|Label}} property which allows "renaming" the object to something more descriptive. The internal {{incode|Name}} actually remains fixed, but the user editable {{incode|Label}} can be used in most situations where the {{incode|Name}} would be used. In common usage in the program and the documentation, "renaming" means changing the {{incode|Label}} and not the actual {{incode|Name}} of the object.

Revision as of 14:59, 14 July 2020

Introduction

Tous les objets du programme ont un object name qui les identifie de manière unique dans un Document donné.

Ces informations s'appliquent à tous les objets dérivés de App DocumentObject (classe App::DocumentObject), qui comprend essentiellement tous les objets qu'il est possible de créer dans un document.

Les Names

Il existe différentes propriétés pour les noms:

  • Le Name ne peut contenir que des caractères alphanumériques simples et le trait de soulignement, [_0-9a-zA-Z].
  • Le Name ne peut pas commencer par un nombre. Il doit commencer par une lettre ou le trait de soulignement, [_a-zA-Z].
  • Le Name est attribué au moment de la création de l'objet ensuite, il n'est plus modifiable. L'objet ne peut jamais être renommé.
  • Le Name doit être unique dans tout le document. Peu importe si deux objets sont de types complètement différents, par exemple, l'un est un PartDesign Poche et l'autre est un Arch Mur. Ils doivent avoir des noms différents.
  • Lors de la création d'un objet du même type, normalement le nom est augmenté d'un numéro séquentiel par exemple Box, Box001, Box002 etc.... Cela permet d'éviter la collusion des noms..
  • Une fois l'objet supprimé, son Name devient disponible pour être utilisé par un objet nouvellement créé. Cela signifie que si Box, Box001 et Box002 existent et que nous supprimons le premier élément, la boîte suivante créée avec Part Cube ne sera pas Box003, ce sera à nouveau Box, cette chaîne étant disponible pour être réutilisée. Notez qu'il n'est pas possible de renommer Box001 ou Box002 en Box car leurs noms sont fixes.

In summary, the Name essentially acts like a unique identifier (UID) for an object. Since a unique Name is very restrictive, all objects also have a Label property which allows "renaming" the object to something more descriptive. The internal Name actually remains fixed, but the user editable Label can be used in most situations where the Name would be used. In common usage in the program and the documentation, "renaming" means changing the Label and not the actual Name of the object.

Labels

There are various properties for Labels:

  • The Label can accept any UTF8 string, including accents and spaces.
  • The tree view actually displays the Label of the object, not the Name. Therefore, whenever a new object is created, it is a good practice to change the Label to a more descriptive string. To rename (relabel) the object, select it in the tree view and press F2, or open the context menu (right-click) and choose Rename.
  • Even after an object was renamed (relabelled), the internal Name will still be reported in many places, for example, in the status bar or in the selection view, when the object is selected.
  • Since the internal functions of the program refer to the objects by Name, many dialogs will display the Name first, followed by the user editable Label in parentheses, for example, Box (Extruded piece).
  • By default the Label is unique, just like the Name. However, this behavior can be changed in the preferences editor, Edit → Preferences → General → Document → Allow duplicate object labels in one document. This means that in general the Label is not unique in the document, and may actually be repeated. However, the recommendation is to keep the Label unique, as this is probably what is most useful to identify different objects. When writing custom functions that manipulate objects, the methods should use the Name of the object rather than its Label to guarantee that the correct object is used.

Label2

This property was introduced in v0.19. It is a simple string that can contain arbitrary text, and therefore can be used for documenting (describing with more detail) the created object.

  • In the tree view edit the field next to the icon, under "Description", by clicking on it and pressing F2.
  • You can also change this property by modifying the Label2 attribute from the Python console.
  • The DonnéesLabel2 attribute is normally hidden in the property editor but can be made visible by opening the context menu (right click) and selecting Show all.

Scripting

See also: FreeCAD Scripting Basics, and scripted objects.

Any object in the software is internally created with the addObject() method of the document. The majority of 2D and 3D objects that the user will see in the 3D view are derived from a Part Feature. In the following example, the object created is a Part Box.

import FreeCAD as App

doc = App.newDocument()
obj = doc.addObject("Part::Box", "Name")
obj.Label = "Custom label"

Name

The addObject function has two basic string arguments.

  • The first argument indicates the type of object, in this case, "Part::Box".
  • The second argument is a string that defines the Name attribute. If it is not provided, it defaults to the same name as the class of the object, that is, "Part__Box", where the two invalid symbols, the colons ::, are replaced by two underscores __.
    • The Name can only include simple alphanumeric characters, and the underscore, [_0-9a-zA-Z]. If other symbols are given, these will be converted to underscores; for example, "A+B:C*" is converted to "A_B_C_".
    • The Name cannot start with a number; it must start with a letter or the underscore, [_a-zA-Z]. For example, "123ABC" is converted to "_23ABC".
    • The Name is fixed at creation time; it cannot be modified afterwards.
    • The Name must be unique in the entire document. If the same "Name" is used, a sequential number will be appended automatically so that the resulting names are unique; for example, if "Name" already exists, then new objects will be called "Name001", "Name002", "Name003", etc.

Label

The Label is a property of the created object and can be changed to a more meaningful text.

  • Upon creating the object, the Label is the same as the Name.
  • However, unlike the Name, the Label can accept any UTF8 string, including accents and spaces.
  • The Label can be changed at any point in time just by assigning the desired string, obj.Label = "New label"

Getting an object by Name or Label

All objects in a document are data attributes of the corresponding Document object. The attribute's name correspond to the internal Name of the object.

import FreeCAD as App

obj1 = App.ActiveDocument.Box
obj2 = App.ActiveDocument.Box001
obj3 = App.ActiveDocument.Box002

This is equivalent to using the getObject method of the Document.

import FreeCAD as App

obj1 = App.ActiveDocument.getObject('Box')
obj2 = App.ActiveDocument.getObject('Box001')
obj3 = App.ActiveDocument.getObject('Box002')

However, it is also possible to get the object by the more descriptive Label.

import FreeCAD as App

obj1 = App.ActiveDocument.getObjectsByLabel("Concrete wall")[0]
obj2 = App.ActiveDocument.getObjectsByLabel("Custom parallelepiped")[0]
obj3 = App.ActiveDocument.getObjectsByLabel("Some special name for this cube__002")[0]

Given that the Label is in general not unique, the getObjectsByLabel method returns a list with all objects found with that Label. However, if the Label is unique in the document then the first element in that list should be the desired object.